/* Example of threads in C++.
 * CSE 374, 2015-03 BM
 */

#include <thread>
#include <mutex>
#include <iostream>

using namespace std;

// the function that thread alice will run
void alice_f() {
  for (int i=0; i<1000; i++) {
    cout << "Alice prints " << i << endl;
  }
}

// the function that thread bob will run
void bob_f() {
  for (int i=0; i<1000; i++) {
    cout << "Bob prints " << i << endl;
  }
}

// main() is always executed by the main program thread.
int main() {
  /* concurrent threads that may be running: main */

  // create and start a thread that will run alice_f
  thread alice(alice_f);   

  /* concurrent threads that may be running: alice, main */

  // create and start a thread that will run bob_f
  thread bob(bob_f); 

  /* concurrent threads that may be running: alice, bob, main */

  // wait until the alice thread finishes
  alice.join();

  /* concurrent threads that may be running: bob, main */

  // wait until the bob thread finishes
  bob.join();

  /* concurrent threads that may be running: main */
}
